
/* Programme compile avec Turbo C version 2.0 sous MS-Dos */

#include <stdio.h>
#include <conio.h>
#include   <dos.h>

#define LPT1 0x378
#define LPT2 0x278
#define LPT3 0x3BC

/*
 Brochage de la puce :
 - contact 1 : +5V (Vcc)
 - contact 5 : 0v (Gnd, c'est a dire la masse) ; la piste en cuivre
	       qui constitue ce contact est facile a reconnaitre, car
	       elle se prolonge souvent vers le centre de la puce.
 - contact 2 : RAZ / UP\ ; lors des fronts montant de l'horloge :
	       - si RAZ / UP\ = '1' : remise a zero du compteur interne.
	       - si RAZ / UP\ = '0' : passage a l'adresse suivante du
		 compteur interne et lecture de chaque bit.
	       Il est commande par le bit B2 du port parallele.
 - contact 3 : L'horloge H ; elle est active sur un front montant.
	       Elle est commandee par le bit B1 du port parallele.
 - contact 7 : La sortie de la puce, qui va sur l'entree BUSY du
	       port parallele.
 Le protocole utilise ces cinq contacts de la puce ; le contact
 6 n'est pas utilise, mais il semble plus prudent de le relier
 au +5v pour une bonne compatibilite.
 Les contacts 4 et 8 ne sont pas utilises ; parfois, la puce
 n'a que six contacts : les 4 et 8 sont tout simplement absents.
*/

int  PortLPT;

void AlimON(int port)
{ /* on met a '1' les bits B4, B5, B6 et B7 du port // : */
  outportb(port,0xF0);
}

void AlimOFF(int port)
{ /* Tous les bits a '0' : */
  outportb(port,0x00);
}

char LireSortie(int port)
{ /* Lecture du bit B7 du port d'entree : */
  if ((inportb(port+1) & 0x80)==0x00) return '1';
				 else return '0';
}

void Horloge(int port, int bit)
{
  unsigned char valeur;

  valeur=inportb(port); /* Lire la valeur actuelle */
  if (bit==0) outportb(port,valeur & 0xFD); /* forcer B1 a '0' */
	 else outportb(port,valeur | 0x02); /* forcer B1 a '1' */
}

void RAZ_UP(int port, int bit)
{
  unsigned char valeur;

  valeur=inportb(port); /* Lire la valeur actuelle */
  if (bit==0) outportb(port,valeur & 0xFB); /* forcer B2 a '0' */
	 else outportb(port,valeur | 0x04); /* forcer B2 a '1' */
}

void main(void)
{
  int   n;
  char  BitLu;

  /* Port parallele actif : */
  PortLPT=LPT1; /* ou LPT2, ou LPT3 */

  /* on allume le port : */
  AlimON(PortLPT);

  /* on fait une remise a zero : */
  RAZ_UP(PortLPT,1);  /* Passage en mode 'RAZ'. */
  Horloge(PortLPT,0);
  Horloge(PortLPT,1); /* Front montant. */
  Horloge(PortLPT,0);
  RAZ_UP(PortLPT,0);  /* Retour en mode 'UP'. */

  /* on insert deux retours a la ligne + message d'accueil : */
  printf("\n\n  Contenu de la telecarte Eurochip :");

  /* Lecture des 128 bits (avec les telecartes plus recentes */
  /* remplacer cette valeur par 512 pour lire 512 bits)      */
  for (n=0;n<128;n++)
  {
    /* Front montant sur l'horloge (on est en mode 'UP') :  */
    /*   passage au premier bit la premiere fois            */
    /*   (et aux bits suivants les fois suivantes) :        */
    Horloge(PortLPT,0);
    Horloge(PortLPT,1);

    /* lecture du bit : */
    BitLu=LireSortie(PortLPT);

    /* et affichage : */         /* Mettre :                                 */
    if ((n%32)==0) printf("\n"); /* - un retour a la ligne tous les 32 bits, */
    if ((n%4)==0)  printf(" ");  /* - un espace tous les 4 bits,             */
    if ((n%8)==0)  printf(" ");  /* - plus un second tous les 8 bits.        */
    printf("%c",BitLu);          /* et enfin afficher le bit...              */
  }

  /* Extinction du port : */
  AlimOFF(PortLPT);

  /* on insert deux retours a la ligne : */
  printf("\n\n");

}



